Bug 959720 (pulseview) - Review Request: pulseview - Signal acquisition and analysis GUI for sigrok
Summary: Review Request: pulseview - Signal acquisition and analysis GUI for sigrok
Keywords:
Status: CLOSED ERRATA
Alias: pulseview
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Susi Lehtola
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-05-05 02:42 UTC by Alex G.
Modified: 2013-05-14 04:38 UTC (History)
3 users (show)

Fixed In Version: pulseview-0.1.0-2.fc19
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-05-14 04:38:39 UTC
susi.lehtola: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Alex G. 2013-05-05 02:42:31 UTC
Spec URL: http://g-tech.no-ip.org/~mrnuke/fedrev/pulseview-0.1.0-1/pulseview.spec
SRPM URL: http://g-tech.no-ip.org/~mrnuke/fedrev/pulseview-0.1.0-1/pulseview-0.1.0-1.fc18.src.rpm
Description: 
PulseView is an application for enabling data acquisition and analysis with
test and measurement devices such as logic analyzers, oscilloscopes,
mixed-signal devices, digital multimeters and sensors, etc. It uses sigrok
libraries under the hood.

Fedora Account System Username: mrnuke

After many months in development, upstream made their first official realease of pulseview. This is really cool.

The release was accompanied with a new release libsigrok/decode (dependencies), which I just pushed to rawhide, so it might take a little while until we are able to build pulseview in Koji. I would love to get this approved in time for the Fedora 19 release.

Comment 1 Susi Lehtola 2013-05-06 12:28:31 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated

===== MUST items =====

C/C++:
[x]: Package does not contain kernel modules.
[x]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Development files must be in a -devel package
[x]: Package requires other packages for directories it uses.
[x]: Package uses nothing in %doc for runtime.
[x]: Package is not known to require ExcludeArch.
[x]: Package complies to the Packaging Guidelines
[x]: License field in the package spec file matches the actual license.

**

It's rather odd that every single source file states that the license is GPLv2+, but the readme states that

"PulseView is licensed under the terms of the GNU General Public License
(GPL), version 3 or later.

While some individual source code files are licensed under the GPLv2+, and
some files are licensed under the GPLv3+, this doesn't change the fact that
the program as a whole is licensed under the terms of the GPLv3+ (e.g. also
due to the fact that it links against GPLv3+ libraries)."

This is clearly in error. Maybe contact upstream and ask them to change this?

Also, specify in the spec file that the license comes from README.

**

[!]: Package consistently uses macros (instead of hard-coded directory
     names).

- You are mixing %{name} and pulseview in %files. Choose one and stick with it.


[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[ ]: gtk-update-icon-cache is invoked when required
     Note: icons in pulseview
[x]: Useful -debuginfo package or justification otherwise.
[-]: Large documentation must go in a -doc subpackage.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Each %files section contains %defattr if rpm < 4.4
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package contains desktop file if it is a GUI application.
[x]: Package installs a %{name}.desktop using desktop-file-install if there is
     such a file.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Fully versioned dependency in subpackages, if present.
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present.
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make.
[x]: SourceX tarball generation or download is documented.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define.

===== EXTRA items =====

Generic:
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).


Rpmlint
-------
Checking: pulseview-0.1.0-1.fc20.x86_64.rpm
pulseview.x86_64: W: spelling-error Summary(en_US) sigrok -> grokking
pulseview.x86_64: W: spelling-error %description -l en_US multimeters -> altimeters, millimeters, muleteers
pulseview.x86_64: W: spelling-error %description -l en_US sigrok -> grokking
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

These are OK.

Rpmlint (installed packages)
----------------------------
# rpmlint pulseview
pulseview.x86_64: W: spelling-error Summary(en_US) sigrok -> grokking
pulseview.x86_64: W: spelling-error %description -l en_US multimeters -> altimeters, millimeters, muleteers
pulseview.x86_64: W: spelling-error %description -l en_US sigrok -> grokking
1 packages and 0 specfiles checked; 0 errors, 3 warnings.

Same here.

Requires
--------
pulseview (rpmlib, GLIBC filtered):
    /bin/sh
    hicolor-icon-theme
    libQtCore.so.4()(64bit)
    libQtGui.so.4()(64bit)
    libboost_system-mt.so.1.53.0()(64bit)
    libboost_thread-mt.so.1.53.0()(64bit)
    libc.so.6()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libglib-2.0.so.0()(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    libsigrok.so.1()(64bit)
    libsigrokdecode.so.1()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.1)(64bit)
    rtld(GNU_HASH)



Provides
--------
pulseview:
    pulseview
    pulseview(x86-64)



Source checksums
----------------
http://www.sigrok.org/download/source/pulseview/pulseview-0.1.0.tar.gz :
  CHECKSUM(SHA256) this package     : fa44e60a1a861dd730434a3f21b28ca0b7999d54f38576c9b8dbc766437a064a
  CHECKSUM(SHA256) upstream package : fa44e60a1a861dd730434a3f21b28ca0b7999d54f38576c9b8dbc766437a064a

***

Final comments:


I think you're abusing wildcards for no reason in
 %{_mandir}/man*/*
Since this is only a single file, please replace this by
 %{_mandir}/man1/pulseview.1*


You're also missing a comment for SOURCE1: what's it for, where is it from and has it been sent upstream?

Comment 2 Alex G. 2013-05-06 17:33:59 UTC
> It's rather odd that every single source file states that the license is
> GPLv2+, but the readme states that
> 
> "PulseView is licensed under the terms of the GNU General Public License
> (GPL), version 3 or later.
> 
> While some individual source code files are licensed under the GPLv2+, and
> some files are licensed under the GPLv3+, this doesn't change the fact that
> the program as a whole is licensed under the terms of the GPLv3+ (e.g. also
> due to the fact that it links against GPLv3+ libraries)."
> 
> This is clearly in error. Maybe contact upstream and ask them to change this?
> 
This is actually correct. PulseView links to libsigrok and libsigrokdecode which
are both GPLv3+. While the PulseView sources are GPLv2+, when it is linked and
distributed as a binary, it becomes GPLv3+. It's what the README is saying.

> 
> [!]: Package consistently uses macros (instead of hard-coded directory
>      names).
> 
> - You are mixing %{name} and pulseview in %files. Choose one and stick with
> it.
>
Thanks. fixed
> 
> Final comments:
> 
> 
> I think you're abusing wildcards for no reason in
>  %{_mandir}/man*/*
> Since this is only a single file, please replace this by
>  %{_mandir}/man1/pulseview.1*
>
Thanks. fixed.

> 
> You're also missing a comment for SOURCE1: what's it for, where is it from
> and has it been sent upstream?

A desktop file is required for GUI applications:
https://fedoraproject.org/wiki/Packaging:Guidelines#Desktop_files
> If the package doesn't already include and install its own .desktop file, you
> need to make your own.

Comment 4 Susi Lehtola 2013-05-06 20:19:42 UTC
(In reply to comment #2)
> > This is clearly in error. Maybe contact upstream and ask them to change this?
> > 
> This is actually correct. PulseView links to libsigrok and libsigrokdecode
> which
> are both GPLv3+. While the PulseView sources are GPLv2+, when it is linked
> and
> distributed as a binary, it becomes GPLv3+. It's what the README is saying.

AFAIK this is somewhat debatable, since we're not linking statically. Even more dubious is the case where you dlopen() the library. AFAIK the Fedora convention is pretty much to mark the license field as the license that is produced by the sources in the current package, linkage is not considered here at all.

But in this case the README is pretty clear about the license - even though it goes against the license boilerplates.

> > You're also missing a comment for SOURCE1: what's it for, where is it from
> > and has it been sent upstream?
> 
> A desktop file is required for GUI applications:
> https://fedoraproject.org/wiki/Packaging:Guidelines#Desktop_files
> > If the package doesn't already include and install its own .desktop file, you
> > need to make your own.

Yup, but did you send this already upstream?

**

Anyway, the review is 

APPROVED

Comment 5 Alex G. 2013-05-06 20:52:31 UTC
(In reply to comment #4)
> > A desktop file is required for GUI applications:
> > https://fedoraproject.org/wiki/Packaging:Guidelines#Desktop_files
> > > If the package doesn't already include and install its own .desktop file, you
> > > need to make your own.
> 
> Yup, but did you send this already upstream?
>
Not yet. I've been very busy packaging the release. (Upstream released 4 tarballs yesterday). Will send it soonish.

> **
> 
> Anyway, the review is 
> 
> APPROVED

Thanks!

Comment 6 Alex G. 2013-05-06 20:53:28 UTC
New Package SCM Request
=======================
Package Name: pulseview
Short Description: Signal acquisition and analysis GUI for sigrok
Owners: mrnuke
Branches: f18 f19
InitialCC: mrnuke

Comment 7 Gwyn Ciesla 2013-05-07 13:12:57 UTC
Git done (by process-git-requests).

Comment 8 Fedora Update System 2013-05-09 20:30:50 UTC
pulseview-0.1.0-2.fc19 has been submitted as an update for Fedora 19.
https://admin.fedoraproject.org/updates/pulseview-0.1.0-2.fc19

Comment 9 Fedora Update System 2013-05-10 15:33:44 UTC
pulseview-0.1.0-2.fc19 has been pushed to the Fedora 19 testing repository.

Comment 10 Fedora Update System 2013-05-14 04:38:39 UTC
pulseview-0.1.0-2.fc19 has been pushed to the Fedora 19 stable repository.


Note You need to log in before you can comment on or make changes to this bug.